-----------------------------------------------------
-- 			Gnrateur de Plans Onduls
-- 					Version 2.1
--
-- 				Francois Mourlevat	
-- 				 22 mars 1999
--
--			
-- 	Permet de crer des Plans d'Eau, des Champs
-- 				de Dunes, et des Draps
--
-- 				Programme FREEWARE
-- 			Email : mourl@club-internet.fr
-- 			 url:http://www.chez.com/mourl
-----------------------------------------------------

--------------------------------------------------------------------------------
-------------------------------------------- Dfinition fentre information ------
--------------------------------------------------------------------------------
Rollout propos "A Propos..."
(
	label trfm offset:[0,-10]
	label text1 "Gnrateur de Plans Onduls"
	Label text2 "Version 2.1"
	label text3 "\xa9 1999 par Francois Mourlevat"
	button aiuto "" images:#("pwater.jpg","pwater.jpg",1,1,1,1,1) width:140 offset:[0,10] tooltip:"Documentation, Infos"
	Label aiide "Cliquer l'image pour une Documentation"
	on aiuto pressed do
	(
	messagebox "Gnrateur de Plans Onduls			www.chez.com/mourl\nVersion 2.1				Programme Freeware\n\xa9 98 par Francois Mourlevat
	\n
	\nINFORMATIONS                    _____________________________________
	\nLa vignette de visualisation permet de contrler la cration d'un plan ondul. Elle correspond  la fentre active. Le bouton Regen. Manuel a pour effet de rafrachir la vignette manuellement. Lorsque l'option Regen. Auto est coche, toutes les modifications effectues dans l'interface sont rpercutes dans la vignette de prvisualisation. Cette option peut ralentir le systme et le droulement des curseurs. Il peut donc tre prfrable de dsactiver cette option et d'utiliser le bouton Regen. Manuel ds que l'on souhaite visualiser un rsultat.
	\nSous la zone de prvisualisation, le programme possde une barre de boutons correspondant  6 jeux de slections dterminant diffrentes familles de formes Vous pouvez les utiliser comme base de vos recherches. Dune : Fourni une base de travail pour des reliefs gographiques, les bancs de sables ou de dunes. Drap : Fourni un paramtrage adapt aux tissus. Ruban : L'objet correspond  un ruban animable. Eau : Base de paramtrage correspondant  des plans d'eau, lacs ou piscines. Onde : correspond  de simples rouleaux rguliers. Mosac : Correspond  des motifs gomtriques.
	\nDimensions du Drap : Largeur dtermine la largeur du plan (de 1  1000). Longueur dtermine la longueur de plan (de 1  1000). Densit dfinit la rsolution du maillage (de 1  25). On peut d'autre part fournir le Nom du Plan Ondul ansi que dfinir une Couleur au maillage. Cette couleur n'affecte pas le matriau.
	\nOnde : Amplitude cre des vagues rgulires d'Amplitude variable (de -300  +300). Longueur fait varier l'amplitude des vagues. Sa valeur perturbe la surface en potentialisant l'effet d'Amplitude (de -100  +100). Animation : ce bouton permet d'obtenir un nouvel tat de la surface compte tenu des paramtres tablis. Le principe est de produire des surfaces animes. Il s'agira donc d'utiliser ce bouton pour trouver des cibles de morphing intressantes. 
	\nTempte : Influence produit une torsion de la surface (de 2  100). Apaisement durcit plus ou moins cette torsion (de 1  100). Direction Vent perturbe le rsultat selon une valeur angulaire(de 0  90). La perception de ces 3 fonctions sera d'autant plus claire que les paramtres de l'Onde auront t ports  0 pour l'Amplitude et 0 pour la Longueur. Porter l'Influence au minimum et l'Apaisement au maximum. Faire alors varier les valeurs pour constater les effets.
	\nMatriaux : Affectation Matriaux : cette case  cocher permet d'affecter un matriau au Plan Ondul avant l'action sur le bouton CREATION. Elle n'est pas efficace sur un Plan Ondul existant. Coordonnes de Mapping : Le Plan Ondul possdera ou non des coordonnes de mapping selon l'tat de cette case  cocher. Transparence : Lorsque la case Affectation Matriau est coche, cette option devient active et rend le Plan Ondul plus ou moins opaque. Brillance : Lorsque la case Affectation Matriau est coche, cette option devient active et rend le Plan Ondul plus ou moins brillant.
	\n_____________________________________________________________
	\nContactez moi pour un report de bugs\nEmail : mourl@club-internet.fr" beep:no title:"Gnrateur de Plans Onduls : Documentation"
	)
)
--------------------------------------------------------------------------------------------
-------------------------------------------------- Interface -------------------------------
---------------------------------------------------------------------------------------------
Rollout params "Visualisation"	
(		
	Label rfth ""
	checkbox up "Rgen. Auto." checked:rega align:#right
	button regard "Rgen Manuel" align:#right width:100 offset:[0,10] tooltip:"Mise  Jour de la Vignette"
	bitmap preview width:180 height:120 align:#left offset:[0,-60]
	button go "CREATION!" align:#right width:100 height:38 tooltip:"Cre le Plan Ondul" offset:[0,-45]
	Checkbutton seta "Dunes" height:15 width:50 offset:[0,10] across:6
	Checkbutton setb "Drap" height:15 width:50 offset:[0,10] 
	Checkbutton setc "Ruban" height:15 width:50 offset:[0,10] 
	Checkbutton setd "Eau" height:15 width:50 offset:[0,10] 
	Checkbutton sete "Onde" height:15 width:50 offset:[0,10]
	Checkbutton setf "Mosac" height:15 width:50 offset:[0,10]
	label tgbx "" offset:[0,-10]		
	Group "Dimensions du Drap"
	(
	spinner lar "Largeur" range:[1,1000,dlar] type:#integer align:#center across:3 offset:[0,5]
	spinner lon "Longueur" range:[1,1000,dlon] type:#integer align:#center offset:[0,5]
	spinner dens "Densit" range:[1,25,dres] type:#integer width:80 align:#center offset:[0,5]
	edittext w_name "Nom :" text:ono offset:[0,10] width:100 align:#center across:2	
	colorpicker ascol "Couleur" color:mcor height:15 align:#center offset:[0,10] 
	Label eetr "" offset:[0,-10]
	)
	Group "Onde"
	(
	spinner amp "Amplitude" type:#integer scale:0.01 range:[-300,300,oam] offset:[0,5] align:#center width:70 across:3
	spinner amq "Longueur" type:#integer scale:0.01 range:[-100,100,olo] offset:[0,5] align:#center width:70
	button new_seed "Animation" align:#center offset:[0,2] tooltip:"Gnre une Variation Alatoire de l'Ondulation"	
	label tgbz "" offset:[0,-10]		
	)
	Group "Tempte"
	(
	label tlgut "Influence :22" offset:[0,0] across:3
	label tsca "Apaisement :27" offset:[0,0] 
	label tonda "Direction Vent :30" offset:[0,0]
	slider lgut "" range:[10,500,tfo] type:#float width:100 offset:[0,0] align:#center across:3
	slider sca "" range:[10,1000,tin] type:#float width:100 offset:[0,-0] align:#center
	slider onda "" range:[0,90,tdi] type:#integer width:100 offset:[0,-0] align:#center
	)
	Group "Matriaux"
	(			
	checkbox w_random "Affectation Matriau" checked:mma align:#center across:2
	Checkbox map "Coord. de Mapping" align:#center checked:mcd 
	label topac "Transparence :100" align:#center across:2
	label trefl "Brillance :20" align:#center
	slider opac "" range:[0,100,mtr] type:#integer width:130 align:#center enabled:true across:2
	slider refl "" range:[0,100,mbr] type:#integer width:130 align:#center enabled:true
	)
----------------------------------------------------------------------------------------------------
-------------------------------presets ---------------------------------------------
----------------------------------------------------------------------------------------------------
	on setf changed state do try 
	(
		if setf.state == false then setf.state = true
		if setf.state == true then
		(
		dlar = 60
		dlon = 90
		dres = 12
		oam = 10
		olo = 90
		ono = "Mosac"
		tin = 740
		tfo = 155
		tdi = 30
		seta.state = setb.state = setc.state = setd.state = sete.state = false
		presett ()
		)
	) catch ()
	on seta changed state do try 
	(
		if seta.state == false then seta.state = true
		if seta.state == true then
		(
		dlar = 60
		dlon = 90
		dres = 12
		oam = 10
		olo = 90
		ono = "Dunes"
		tin = 310
		tfo = 380
		tdi = 30
		setf.state = setb.state = setc.state = setd.state = sete.state = false
		presett ()
		)
	) catch ()
	on setb changed state do try
	(
		if setb.state == false then setb.state = true
		if setb.state == true then
		(
		dlar = 60
		dlon = 90
		dres = 12
		oam = 10
		olo = 2
		ono = "Drap"
		tin = 620
		tfo = 325
		tdi = 62
		setf.state =seta.state =  setc.state = setd.state = sete.state = false
		presett ()
		)
	)catch ()
	on setc changed state do try
	(
		if setc.state == false then setc.state = true
		if setc.state == true then
		(
		dlar = 50
		dlon = 3
		dres = 12
		oam = 4
		olo = 100
		ono = "Ruban"
		tin = 400
		tfo = 250
		tdi = 0
		setf.state = setb.state = seta.state = setd.state = sete.state = false
		presett ()
		)
	)catch ()
	on setd changed state do try
	(
		if setd.state == false then setd.state = true
		if setd.state == true then
		(
		dlar = 50
		dlon = 60
		dres = 12
		oam = 0
		olo = 0
		ono = "Eau"
		tin = 10
		tfo = 10
		tdi = 0
		setf.state =setb.state = setc.state = seta.state = sete.state = false
		presett ()
		)
	)catch ()
	on sete changed state do try
	(
		if sete.state == false then sete.state = true
		if sete.state == true then
		(
		dlar = 50
		dlon = 60
		dres = 12
		oam = 30
		olo = 1
		ono = "Onde"
		tin = 10
		tfo = 10
		tdi = 0
		setf.state = setb.state = setc.state = setd.state = seta.state = false
		presett ()
		)
	)catch ()
----------------------------------------------------------------------------------------------------
--------------------------------changement des valeurs ---------------------------------------------
-----------------------------------------------------------------------------------------------------		
	on w_name entered text do ono = w_name.text
	on up changed state do rega = up.state
	on w_random changed state do mma = w_random.state
	on map changed state do mcd = map.state
	on ascol changed color do try
	(
	mcor = ascol.color
	pwater.wirecolor = mcor
	visua ()
	) catch ()
	on lar changed value do try
	(
	dlar = lar.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	pwater.length = (dlar * 10)
	visua ()	
	) catch ()
	on lon changed value do try
	(
	dlon = lon.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	pwater.width = (dlon * 10)
	visua ()	
	) catch ()
	on dens changed value do try
	(
	dres = dens.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	pwater.lengthsegs = dres
	pwater.widthsegs = dres
	visua ()	
	) catch ()
	on amp changed value do try
	(
	oam = amp.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	pwater.wagua.amplitude1 = oam
	pwater.wagua.amplitude2 = oam
	pwater.wagub.amplitude1 = oam
	pwater.wagub.amplitude2 = oam
	pwater.waguc.amplitude1 = oam
	pwater.waguc.amplitude2 = oam
	visua ()	
	) catch ()
	on amq changed value do try
	(
	olo = amq.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	pwater.wagua.wavelength = olo
	pwater.wagub.wavelength = olo
	pwater.waguc.wavelength = olo
	visua ()	
	) catch ()
	on sca changed value do try
	(
	tin = sca.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	tsca.text = "Apaisement :" + ((tin as integer)/10) as string
	pwater.turbulence.scale = tin
	visua ()	
	) catch ()
	on lgut changed value do try 
	(
	tfo = lgut.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	tlgut.text = "Influence :" + ((tfo as integer)/5) as string
	pwater.turbulence.strength = [tfo,tfo,tfo]
	visua ()	
	) catch ()
	on opac changed value do try
	(
		mtr = opac.value
		if w_random.checked then 
		(
			if pwater.material!= undefined then
			(
			topac.text = "Transparence :" + mtr as string
			pwater.material.opacity = mtr
			visua ()	
			)
		)
	) catch ()	
	on refl changed value do try
	(
		mbr = refl.value
		if pwater.material!= undefined then
		(
			if w_random.checked then 
			(
			trefl.text = "Brillance :" + mbr as string
			pwater.material.shininess = mbr
			visua ()	
			)
		)
	) catch ()	
	on onda changed value do try
	(
	tdi = onda.value
	seta.state = setb.state = setc.state = setd.state = sete.state = setf.state = false
	tonda.text = "Direction Vent : " + tdi as string
	pwater.wagub.gizmo.rotation = quat tdi z_axis
	pwater.waguc.gizmo.rotation = quat -tdi z_axis
	visua ()	
	) catch ()
	on regard pressed do
	(
	local bm = 	render frame:currenttime \
				outputwidth:180 \
				outputheight:120 \
				vfb:off \
				shadows:off
	preview.bitmap = bm
	gc ()
	)
	on new_seed pressed do try
	(
	pwater.turbulence.seed = random 0 32000
	visua ()	
	) catch ()
-------------------------------------------------------------------------------------------
------------------------------------------------- Cration du plan ondul------------------
---------------------------------------------------------------------------------------------
	on go pressed do
	(
		progressStart "Gnration du Plan Ondul..."
		getProgressCancel ()
		progressUpdate 0
		pwater = (		quadpatch \
						length:(lar.value * 10) \
						width:(lon.value * 10) \
						widthsegs:dens.value \
						lengthsegs:dens.value \
						pos:[0,0,0])
		progressUpdate 10
		pwater.name = w_name.text as string
		progressUpdate 20
		pwater.wirecolor = ascol.color
		progressUpdate 30
		addModifier pwater (	wave \
								name:"wagua" \
								amplitude1:amp.value \
								amplitude2:amp.value \
								wavelength:amq.value)
		progressUpdate 40
		pwater.wagua.gizmo.rotation = quat tdi z_axis
		progressUpdate 50			
		addModifier pwater (	wave \
								name:"wagub" \
								amplitude1:amp.value \
								amplitude2:amp.value \
								wavelength:amq.value)
		progressUpdate 60			
		pwater.wagub.gizmo.rotation = quat tdi z_axis
		progressUpdate 70			
		addModifier pwater (	wave \
								name:"waguc" \
								amplitude1:amp.value \
								amplitude2:amp.value \
								wavelength:amq.value)
		progressUpdate 80
		pwater.waguc.gizmo.rotation = quat tdi z_axis
		progressUpdate 90			
		addModifier pwater (	noiseModifier \
								name:"turbulence" \
								fractal:false \
								seed:(random 0 32000) \
								scale:sca.value \
								strength:[lgut.value,lgut.value,lgut.value])
		progressUpdate 95
		if map.checked then addmodifier pwater(uvwmap name:"Mapping" mapType:0)
		progressUpdate 98
		if w_random.checked then 	pwater.material = standardmaterial \
									name:"pwatermtl" \
									opcity:opac.value \
									shininess:refl.value \
									shinestrength:78 \
									ambient:(random (color 0 0 30) (color 0 0 60)) \
									diffuse:(random (color 60 75 220) (color 60 170 220))
		progressUpdate 100
		visua ()	
		progressEnd ()
	)
	on params close do
	(
	plwater.setup.enabled = true
	plwater.goout.enabled = false		
	)
)	
--------------------------------------------------------------------------------------------
--------------------- ouvrir et fermer la routine ---------------------------------------
---------------------------------------------------------------------------------------------
fn presett =
(
params.lar.value = dlar
params.lon.value = dlon
params.dens.value = dres
params.amp.value = oam
params.amq.value = olo
params.w_name.text = ono
params.sca.value = tin 
params.lgut.value = tfo
params.onda.value = tdi 
params.tsca.text = "Apaisement :" + ((params.sca.value as integer)/10) as string
params.tlgut.text = "Influence :" + ((params.lgut.value as integer)/5) as string
params.tonda.text = "Direction Vent : " + params.onda.value as string
pwater.length = (params.lar.value * 10)
pwater.width = (params.lon.value * 10)
pwater.lengthsegs = params.dens.value
pwater.widthsegs = params.dens.value
pwater.wagua.amplitude1 = params.amp.value
pwater.wagua.amplitude2 = params.amp.value
pwater.wagub.amplitude1 = params.amp.value
pwater.wagub.amplitude2 = params.amp.value
pwater.waguc.amplitude1 = params.amp.value
pwater.waguc.amplitude2 = params.amp.value
pwater.wagua.wavelength = params.amq.value
pwater.wagub.wavelength = params.amq.value
pwater.waguc.wavelength = params.amq.value
pwater.turbulence.scale = params.sca.value
pwater.turbulence.strength = [params.lgut.value,params.lgut.value,params.lgut.value]
pwater.wagub.gizmo.rotation = quat params.onda.value z_axis
pwater.waguc.gizmo.rotation = quat -params.onda.value z_axis
visua ()
)
fn visua =
(
if params.up.checked then
	(
	local bm = 	render frame:currenttime \
				outputwidth:180 \
				outputheight:120 \
				vfb:off \
				shadows:off
	params.preview.bitmap = bm
	gc ()
	)
)
ptg
if rega == undefined then rega = mma = true
if mma == undefined then mma = true
if dlar == undefined then dlar = 60
if dlon == undefined then dlon = 90
if dres == undefined then dres = 12
if oam == undefined then oam = 5
if olo == undefined then olo = 4
if ono == undefined then ono = "Drap"
if tin == undefined then tin = 275
if tfo == undefined then tfo = 110
if tdi == undefined then tdi = 30
if mbr == undefined then mbr = 20
if mcd == undefined then mcd = false
if mcor == undefined then mcor = [110,110,30]
if mtr == undefined then mtr = 110
---------------------------------------------------------------------------------
----------------------------------------------- Ddinition panneau de commande --
---------------------------------------------------------------------------------
Utility plwater "Plans Onduls 2.1"
(
	listbox fmt "" items:#("     Gnrateur de Plans","             Onduls","            Version 2.1","   \xa9 1999 F. Mourlevat","","   www.chez.com/mourl") selection:0 height:6 offset:[0,5] enabled:false
	Group "Gestion Fentre"
	(
	button setup "Ouvrir Plans Onduls" tooltip:"Ouvrir la fentre"
	button goout "Fermer Plans Onduls" tooltip:"Fermer la fentre" enabled:false
	)
	fn pl_setup =
	(
		max2_version = true
		ver_check = ([128,128,128] as color)*128
		if ver_check.r > 256 then max2_version = false
		if max2_version then
		(
			try closerolloutfloater err catch ()
			setup.enabled = false
			goout.enabled = false
			rollout vermax "Incompatibilit de version"
			(
			label VG_err1 ""
			label VG_err2 "3D Studio Max version 2.1 a t dtect."
			label VG_error ""
			label VG_err3 "Pour ce script, la version 2.5 est requise."
			label VG_err4 ""
			button VG_verquit "Quitter" 
			on VG_verquit pressed do closerolloutfloater err
			)
			err = newrolloutfloater "Plans Onduls 2.1" 250 185
			addrollout vermax err
		)
		else
		(
		ptg = newRolloutFloater "Gnrateur de Plans Onduls 2.1" 350 585 0 0
		addRollout params ptg
		addRollout propos ptg rolledUp:true
		local bm = 	render frame:currenttime \
					outputwidth:180 \
					outputheight:120 \
					vfb:off \
					shadows:off
		params.preview.bitmap = bm
		)
	)
------------------------------------------------------------
--------------- programme -------------------
----------------------------------------------------------
	on goout pressed do
	(
	try CloseRolloutFloater ptg catch ()
	setup.enabled = true
	goout.enabled = false
	)
	on setup pressed do
	(
	try CloseRolloutFloater ptg catch ()
	setup.enabled = false
	goout.enabled = true		
	pl_setup ()		
	)
	on plwater open do
	(
	try CloseRolloutFloater ptg catch ()
	setup.enabled = false
	goout.enabled = true		
	pl_setup ()		
	)
	on plwater close do
	(
	try CloseRolloutFloater ptg catch ()
	)
)